2018-01-22 05:39 CET

View Issue Details Jump to Notes ] Wiki ]
IDProjectCategoryView StatusLast Update
0003722Cult_PublicAttack[All Projects] Generalpublic2017-12-28 09:23
ReporterWepl 
Assigned ToStingRayProject InfoPublic Attack (Cult)
http://www.whdload.de/demos/Cult_PublicAttack.html
 
PrioritynormalSeverityminorReproducibilityalways
StatusresolvedResolutionfixed 
Summary0003722: demo hangs after the cult logo, no quit key or other keys works, nocache/snoop
DescriptionGameVersion: download link
SlaveVersion: only one

demo hangs after the cult logo, no quit key or other keys works, nocache/snoop doesn't help, sound plays sample endless
TagsNo tags attached.
MachineA4000
CPU68060 + PPC
CPUSpeed60
ChipSetAGA
GFXCardCyberVision 64/3D
ChipMem2 MB
FastMem144 MB
WorkbenchOS 3.9
KickROM40 - Kick 3.1
KickSoftSelfmade
WHDLoad18.4beta
importedyes
Attached Files

-Relationships
+Relationships

-Notes

note ~0005736

StingRay (developer)

I have no possibility to test right now but I guess this is an interrupt related problem. Try the 2 attached slaves, do they still have the same problem?

note ~0005741

Wepl (manager)

Tested both Slaves. No difference, hangs after Cult logo.
Maybe you can change the code so that keyboard interrupt still works to allow a dump?

note ~0005744

StingRay (developer)

Level 2/keyboard interrupt is enabled all the time. There must be something seriously wrong somewhere. I'll see if I can find the reason.

note ~0005745

StingRay (developer)

I have attached a slave which skips the logo part (demo waits for raster line 311 in that part which could be possible reason for freezing), does the rest of the demo work?

note ~0005746

Wepl (manager)

It works until the sine scroller, where it hangs the same way. Plasma effect before is working.

note ~0005749

StingRay (developer)

OK, so the raster line wait is not the problem as it's the same in all of these parts. I'll have to dig deeper as this is really strange. My bet is still on interrupt/timing problem though.

note ~0005750

StingRay (developer)

Attached is another slave with disabled NoisePacker replayer which in turn means: no level 6 interrupts. Does the problem still occur?

note ~0005751

Wepl (manager)

It's the same with this Slave.
If there is a problem with stack (double bus fault), it would maybe help to increase BaseMem and set the SP to the end of BaseMem?

note ~0005752

StingRay (developer)

I can try that (currently stack is set to low mem) but I doubt it fixes the problem as then the demo shouldn't just freeze but crash completely. Worth checking though.

note ~0005753

StingRay (developer)

Slave attached which uses ext. mem for USP and SSP, any difference?

note ~0005754

Wepl (manager)

No difference.
I made a dump at the Cult logo, SSP is stiil at $7f8?!

note ~0005755

StingRay (developer)

Indeed, I didn't set ExpMem correctly in the slave header, sorry. Has been fixed, USP/SSP are definitely in ExpMem now (I checked), any difference now?

note ~0005758

Wepl (manager)

It still freezes.
I don't understand why you have moved the stack to Exp. If due a problem the stack usage increases a lot and causes a double bus fault when it leaves the allowed ram, this will happen in ExpMem the same like on address 0. I suggested to put it at the end of BaseMem. Then it will probably overwrite the own code which may end in fault detectable by WHDLoad.
But maybe it is also a different problem..

note ~0005759

StingRay (developer)

End of base mem doesn't work as demo accesses the whole chip mem! Which was the reason that I moved it down to low mem at $1000.w initially. And as I already said, I doubt the stack location is the problem as then then demo should crash instead of freeze. My guess is still interrupt/timing problem.

I'll inspect the code some more, seeing that the plasma part does not freeze there's at least something I can work with.

note ~0005761

StingRay (developer)

To rule out the stack pointer as cause of the problem I have attached a new slave which uses stack set to end of BaseMem. I've only adapted the code for the first part so demo will definitely crash in later parts. If it doesn't freeze anymore in the logo part that is.

note ~0005762

Wepl (manager)

The new Slave hangs the same way. Sorry.

note ~0005768

Psygore (manager)

I assume that the slave runs always in supervisor mode, maybe in user mode (with different location for usp and ssp) could help...just an idea.

note ~0005967

StingRay (developer)

I finally got around to trying Psygore's suggestion and what can I say? Thanks Psygore, your hint regarding running the demo in user mode was spot on, it fixed the problem. Thanks. :)

note ~0005968

Psygore (manager)

You are welcome StingRay :)

Happy holidays :)
+Notes

-Issue History
Date Modified Username Field Change
2017-09-04 22:54 administrator New Issue
2017-09-04 22:54 administrator Status new => assigned
2017-09-04 22:54 administrator Assigned To => StingRay
2017-09-11 13:31 StingRay Note Added: 0005736
2017-09-11 13:31 StingRay File Added: PublicAttack_Ack.slave
2017-09-11 13:32 StingRay File Added: PublicAttack_Int.slave
2017-09-12 21:31 Wepl Note Added: 0005741
2017-09-12 23:05 StingRay Note Added: 0005744
2017-09-12 23:35 StingRay File Added: PublicAttackNoPart1.slave
2017-09-12 23:35 StingRay Note Added: 0005745
2017-09-13 01:04 Wepl Note Added: 0005746
2017-09-13 15:06 StingRay Note Added: 0005749
2017-09-13 15:27 StingRay File Added: PublicAttackNoLev6.slave
2017-09-13 15:27 StingRay Note Added: 0005750
2017-09-13 20:03 Wepl Note Added: 0005751
2017-09-13 20:57 StingRay Note Added: 0005752
2017-09-13 21:08 StingRay File Added: PublicAttackRelStack.slave
2017-09-13 21:08 StingRay Note Added: 0005753
2017-09-14 00:47 Wepl Note Added: 0005754
2017-09-14 07:32 StingRay Note Added: 0005755
2017-09-14 07:32 StingRay File Added: PublicAttack_RelStack2.slave
2017-09-14 23:49 Wepl Note Added: 0005758
2017-09-15 08:37 StingRay Note Added: 0005759
2017-09-15 15:05 StingRay File Added: PublicAttack_SPBase.slave
2017-09-15 15:05 StingRay Note Added: 0005761
2017-09-16 11:22 Wepl Note Added: 0005762
2017-09-18 16:02 Psygore Note Added: 0005768
2017-12-27 15:13 StingRay Note Added: 0005967
2017-12-27 15:13 StingRay Status assigned => resolved
2017-12-27 15:13 StingRay Resolution open => fixed
2017-12-28 09:23 Psygore Note Added: 0005968
+Issue History